% Copyright (C) 2008-2010 - Consortium Scilab - Digiteo - Michael Baudin
% Copyright (C) 2008 - Consortium Scilab - Digiteo - Yann Collette
%
% This file must be used under the terms of the 
% Creative Commons Attribution-ShareAlike 3.0 Unported License :
% http://creativecommons.org/licenses/by-sa/3.0/

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Introduction}

The goal of this document is to give an overview of the 
future possible computational (mathematical) developments in Scilab. 
Two main types of possible evolutions are analyzed :
\begin{itemize}
 \item update of existing features,
 \item creation of new features.
\end{itemize}

This document is an open-source project. 
The \LaTeX sources are available on the Scilab Forge:
\begin{center}
\url{http://forge.scilab.org/index.php/p/docmathroadmap}
\end{center}
The \LaTeX sources are provided under the terms of the 
Creative Commons Attribution-ShareAlike 3.0 Unported License:
\begin{center}
\url{http://creativecommons.org/licenses/by-sa/3.0}
\end{center}

We emphasize that this document is an exploration of possible 
developments. 
It is \emph{not} a definitive planning for these developments.
It is draft and may remain a dynamical draft depending on the new 
developments made in Scilab.
Hence, if you feel that the proposals suggested in this document
do not match your particular needs, please contact the authors and 
share your point of view.

In this introduction, we analyze the context of the computational features in Scilab. 
We begin by presenting the reasons for the update or the creation of 
new computational features in Scilab. 
Then we present the difficulties raised by the complexity of Scilab, 
which makes it difficult to have an overview of its current state. 
We briefly present a list of commercial or open source softwares which 
may serve as a comparison with Scilab and present resources which 
provide benchmarks for speed or accuracy of numerical softwares.
In the final section, we present the methodology used in this 
document.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Features vs use cases}

It is completely impossible to discuss a mathematical roadmap without 
analysing the whole purpose of Scilab. 
As any other software, Scilab provide features which allow to solve use cases.

This is presented in figure \ref{fig-mathdimensions}, where the two dimensions 
of this situation are detailed.
One the computational features axis, we find, for example, elementary 
functions, linear algebra, control, ordinary differential equations (ODE), 
optimization, statistics, control and many other features available in Scilab.
On the use case axis, we find the automotive industry, aerospace, chemistry, 
finance and many other application domains for Scilab.

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{mathroadmap/mathdimensions.pdf}
\end{center}
\caption{The two dimensions of Scilab : features and use cases.}
\label{fig-mathdimensions}
\end{figure}

Historically, the first features available in Matlab, the ancestor of 
Scilab, were linear algebra, driven by the will to use linear 
algebra libraries such as Lapack and Eispack. 
Then, engineers realized that this was a tremendous tool for Control, and 
add the associated features, plus ordinary differential equations.
The Simulink tool and its Scilab counterpart, XCos, were created for 
that particular purpose.
Afterwards, engineers in other fields found that it was possible to 
use this tool for many other use cases and asked for new features 
such as optimization and statistics.
All in all, use case are driving the need for computational features
in Scilab, under the condition that these features can be easily 
provided by Open Source libraries.

The question that this document tries to analyze is the "..." presented 
in the figure \ref{fig-mathdimensions} in both dimensions.
More specifically, we try to find 
\begin{itemize}
 \item new use cases,
 \item new features or an update of existing ones.
\end{itemize}
Indeed, it may happen that existing features have performance 
or accuracy limitations. 
In some cases, existing features are not allowing to completely
solve a particular use case.

This situation is presented in the figure \ref{fig-mathstate}, where 
the round shapes represent the areas defined by existing features, 
the "U" symbols represent existing features and the question marks "?" represent
the new features to be created. 

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{mathroadmap/mathstate.pdf}
\end{center}
\caption{The current state of Scilab. }
\label{fig-mathstate}
\end{figure}

The need for update comes in two flavors : sometimes only a part of 
the feature is to be updated, while sometimes the whole component 
is to be replaced. 
For example, the ODE solver in Scilab is based on OdePack, which
is efficient, but may be completely replaced by the up-to-date Sun Dials 
library.
In some cases, there a complete domain which is not covered by Scilab.
For example, there is currently no component to solve systems of partial 
differential equations associated with conservation laws (that is, non 
linear hyperbolic systems).
In some other cases, there are existing features which are almost 
completely filling a domain, but not exactly. 
For example, Scilab provide iterative sparse linear algebra solvers, but 
not the associated preconditionners.
There may be situations where there are a small number of existing 
features which fills basic situations, but more advanced needs are 
unsatisfied. For example, the current statistics features are existing 
in Scilab, but there are many more advanced statistics features which 
are missing.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{What for ?}

There may be a variety of reasons for the update or the creation of new features in Scilab. 
\begin{itemize}
  \item A feature is completely missing. For example, there is currently
  no nonlinear optimization solver with non linear constraints. This
  feature is provided by the fmincon function in Matlab, for example.
  
  \item Accuracy : the feature exists in Scilab, but its accuracy is
  poor. For example, we may wonder why the value of $sin(2^64)$ is not the
  same in Scilab on all operating systems.
  
  \item Speed : the feature exists in Scilab, but it is slow. For
  example, the sparse linear algebra "lufact" function is slow, compared
  to the sparse LU decomposition provided in the UMFPACK module of Scilab.
  
  \item Documentation : the feature exists, but is so poorly documented
  that it is, eventually, unusable. For example, the previous versions of
  Scilab did not provide enough examples for the nonlinear unconstrained
  "optim" function. The tolerances for this functions still lack of
  documentation, because we actually do not know much about their actual
  use in the source code.
  
  \item Bugs / limitations / lack of tests : the feature exists, but has
  bugs. For example, the bug \href{http://bugzilla.scilab.org/
  show_bug.cgi?id=7101}{\#7101} shows that there is a problem with the use
  of the "roots" function, depending on the operating system. For example,
  the bug \href{http://bugzilla.scilab.org/show_bug.cgi?id=7569}{\#7569} shows
  that several inverse distribution functions are associated with a
  limited precision of 8 digits (instead of the upper limit 17 digits).
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{The current state}

In order to suggest new features, it is (obviously) necessary to have 
the knowledge of the existing features. 
This is much more complicated that it looks.

For example, it is not straightforward to fully understand the features 
available in Scilab with respect to sparse linear algebra, or 
optimization. 
The reason of this problem is that several authors have 
developped several tools, each one devoted to a particular feature. 
This work has not been systematically been made consistent with existing 
features. 

Moreover, a large amount of features is available in toolboxes. These 
toolboxes cover many computational areas and are developped by many 
authors, most of them being outside the Consortium. 
The toolboxes do not always provide the features missing in Scilab (in some cases, the 
features are the same). 
Another issue is that the toolboxes are not 
always maintained by their authors, which leads to packages which do not 
work with the latests versions of Scilab.

For example, Scilab provides iterative sparse linear algebra solvers, 
but do not provide preconditionners. 
Still, preconditionners are available in the Scilin toolbox, but this toolbox has not been 
maintained and does not work for the latests versions of Scilab.

As another example, Scilab provides several optimization features. But 
there is also a large number of features which are available in 
toolboxes. The simple task of managing the list of existing optimization 
features available either in Scilab or in toolboxes is complicated. This 
is why the document "Optimization in Scilab" \cite{OptimScilab2010} has been written. 
Obviously, the current work would be much more easy if such a 
document was available for each domain covered by Scilab.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Other softwares}

Updating existing computational features or integrating new features in Scilab may be driven 
by comparisons with other softwares. 

As expressed by Alan Edelman, we can first focus on the 800 pound gorilla, Matlab. 
One of the reason of the success of Matlab is the number of features which are available in this tool. 
Moreover, Cleve Moler is a scientific leader in applied mathematics. 
This is why, in the next section, we analyze the features provided by Matlab in each domain.

There are other softwares that we can consider for comparison purposes, including two major open source projects :
\begin{itemize}
 \item \href{http://www.gnu.org/software/octave}{Octave}
 \item \href{http://www.r-project.org}{R} : The R Project for Statistical Computing
 \item \href{http://www.aptech.com}{Gauss} : Aptech
 \item \href{http://www.ni.com/labview}{LabVIEW} : National Instruments
\end{itemize}

Alternatively, we can also consider the open source project FreeMat :
\url{http://freemat.sourceforge.net/}

In practice, some features in Scilab can often be compared with the 
features provided by spreadsheet programs. 
Indeed, many users are making use of both types of softwares (that is, interpreted languages such as 
Scilab, or spreadsheet programs such as OpenOffice) during the same work 
session or inside a workflow. 
In the case where the two softwares 
provide exactly the same features, such as generating random numbers, or 
computing a distribution function, the accuracy of the softwares can be 
compared. 
This topic is covered is the next sections.

In order to suggest to update existing features or to introduce new ones, we may get some help from benchmarking Scilab. The most common type of benchmark is measuring the performance. But some authors also measure the quality of the documentation, the graphics, etc... One point which is specific to numerical softwares is the accuracy of their computations. These topics are covered in the next sections. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Benchmarking speed}

Stefan Steinhaus did a deep comparison of mathematical programs for data analysis. 
The work has been sustained from 1997 to 2008. He reported his work at :
\url{http://www.scientificweb.com/ncrunch/} 
and the latest version (2008) of his benchmark is available in \cite{Steinhaus2008}.

His benchmark included Scilab and numerical and symbolic commercial 
softwares, such as Gauss, Maple, Mathematica, Matlab, O-Matrix and 
OxMetric. He considered the cost (in \$ or EUR), the installation, 
learnability, usability, math. features, graphics, data management, 
portability and speed.

There are other benchmarks as well :
\begin{itemize}
  \item \href{http://www.sciviews.org/benchmark}{Benchmark} by Philippe 
  Grosjean in 2003 and its older version \href{http://www.sciviews.org/
  benchmark/benchmark1.html}{Benchmark \#1}
  \item \href{http://www.derekroconnor.net/Software/BenchAug06.pdf}{Simple Benchmarks forMatlab and Clones} 
  by Derek O'Connor in 2006
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Benchmarking accuracy}

It may happen that there is a trade-off between speed and accuracy. 
This is why authors like Edelman or Mc Cullough considered the accuracy of softwares like Scilab, Matlab or Excel.

In "The accuracy of statistical distributions in Microsoft Excel 2007" - 
A. Talha Yalta, Computational Statistics and Data Analysis 52 (2008) 
4579-4586, the author provides an assessment of the statistical distributions in Microsoft Excel versions 97
through 2007 along with two competing spreadsheet programs, namely Gnumeric 1.7.11
and OpenOffice.org Calc 2.3.0. He finds that the accuracy of various statistical functions
in Excel 2007 range from unacceptably bad to acceptable but significantly inferior in
comparison to alternative implementations. In particular, for the binomial, Poisson, inverse
standard normal, inverse beta, inverse student?s t, and inverse F distributions, it is possible
to obtain results with zero accurate digits as shown with numerical examples.

Other references on this topic are provided in \href{http://wiki.scilab.org/Contributor_-_stats}{Contributor - stats}.

In "An Analysis of Scientific Computing Environments: A Consumer's View" by Amit Soni \cite{Soni2008},
the author compare commercial and free open source languages and 
softwares. The author compares various simple and complex problems and 
how they can be approached in various languages. This work is done in 
the context of the \href{http://www.nmconsortium.org/}{Numerical 
Mathematical Consortium}. The analysis addresses some incompatibility 
issues within languages and their impact. This work is continued by Alan 
Edelman and presented in "Open Source and Traditional Technical 
Computing" by Alan Edelman \cite{EdelmanOSTTC2010}.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{What not to do}

Symbolic computations were perceived as being out of the scope of Scilab, 
which focuses mainly on numerical computations. 
Whether this choice should remain in the next years is subject to discussion.

TODO : finish that section.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Users and features}

The figure \ref{fig-usersVsFeatures} presents a rather abstract view 
of users compared the features of Scilab. 
Obviously, all users make use of the algebra of matrices, may be 
without even noticing it. 
Indeed, many expression in Scilab, such as \scivar{a*b} for example, 
are involving matrices. 
Hence, it is not technically possible to remove the linear algebra 
features of Scilab, because they are at the core of the design of the 
language.
By contrast, not all users are interested by signal processing or by 
XCos. 

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{mathroadmap/usersVsFeatures.pdf}
\end{center}
\caption{The uses of Scilab compared to the features.}
\label{fig-usersVsFeatures}
\end{figure}

What features would users want in the coming years and for what use cases ?
Anyone willing to share his comments is invited to contact the authors of this 
report. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Methodology used in this document}

For each mathematical problem, we analyze the following points :
\begin{itemize}
 \item what is the current state of Scilab ?
 \item what features are to provide ?
 \item why it fits in Scilab scope ?
 \item is there existing library to connect to Scilab ?
 \item is there a Scilab toolbox providing the feature ?
 \item does Matlab provide an equivalent feature ?
\end{itemize}

Detailed feature requests should be written as "Scilab Enhancement Proposals" and not in this document.

When a library is suggested for connection, we pay attention to at least the following points :
\begin{itemize}
 \item licence : is the license authorizes the inclusion in Scilab ?
 \item language : is the language compatible with Scilab ?
 \item mathematical algorithms : is the algorithm efficient, robust, fast, up-to-date ?
 \item documentation : is the library correctly documented with respect to Scilab requirements ?
 \item tests : is the library tested ?
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Overview of Scilab}

In this section, we try to make a complete overview of Scilab. 
The goal of this section is to give a brief description of all the 
computational features of Scilab and to emphasize the main design 
choices and the main issues.

We separate three levels of features in Scilab, each associated with a 
set of functions.
\begin{itemize}
\item Basics: the features used by all users, 
\item Classics in numerical analysis: the features used by many users.
\item Advanced methods: the features used by some users, but obviously not all.
\end{itemize}
For each set of functions, we make a brief overview of:
\begin{itemize}
\item the computational features in this set,
\item the libraries which supports the features,
\item the strong points of Scilab in this set,
\item the issues.
\end{itemize}

In this section, we choose a style which is the one usually 
practiced in slides rather than in technical reports: this is on purpose, in order to 
produce a shorter document.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Basics}

In this section, we present the features which cannot be removed from Scilab. 
We consider that 100\% of the users actually use all these features. 
These features are typical in interpreted languages such as Matlab, Octave, Python (SciPy) 
or even in symbolic computationnal tools such as Maxima, Mathematica or Maple.

This section is partially based on the presentation and analysis presented in 
\cite{BaudinIntroScilab2010,BaudinScilabNotNaive2010,BaudinOptimInScilab2010,BaudinDiscProbasInScilab2010,
BaudinIntroOptimInScilab2010,BaudinUnconsOptimInScilab2010,BaudinNelderMead2010,BaudinSteer2009,
introScilabGomez2007,introScilabGomez1999}.

\subsubsection{Features}

\begin{itemize}
\item Matrix algebra: \scivar{+, -, *, ./}
Typical statement is \scivar{C=A*B} where \scivar{A}, \scivar{B} are real or complex matrices.
\item Elementary functions : \scivar{cos, sin, exp, log}, power ($\hat{\;}$)...
Typical statement is \scivar{y=sin(x)} where x is real or complex matrix.
\item matrix functions : \scifun{expm, pow, logm, cosm,} etc...
\item Special functions : \scifun{gamma, beta, erf,} etc...
\item Dense linear algebra: \scifun{backslash, lu, spec, svd, chol,} least squares
Typical statement is \scivar{x=A\\b} where \scivar{A,b} are real or complex matrix.
\item Foating point number functions: \scifun{\%eps, frexp, number\_properties, ieee, nearfloat}
\item test matrices: \scifun{testmatrix} (Franck, Hilbert, Magic squares), Toeplitz
\item discrete maths: \scifun{factorial, permute, perms,} 	...
\end{itemize}

\subsubsection{Libraries}
The libraries which are providing the basic computational features in Scilab are the following.
\begin{itemize}
\item BLAS \cite{BlasWWW}
 \item LAPACK \cite{LapackWWW}
 \item SLATEC \cite{NetlibSlatec} : e.g. \scifun{bessel}
 \item SPECFUN \cite{NetlibSpecfun1990} : e.g. \scifun{calerf}
 \item macros : e.g. \scifun{erfinv}
 \item Fortran (e.g. complex functions such as complex \scifun{tan})
\end{itemize}

\subsubsection{Strong points}
In this section, we describe the main advantages of using the basic features of Scilab.
\begin{itemize}
\item Optimized BLAS optimized implementations:
  \begin{itemize}
  \item Using Intel MKL \cite{IntelMKLWWW} on Windows.
  \item Using ATLAS \cite{AtlasWWW} on Linux.
  \end{itemize}
\item As a consequence, Scilab can be faster than what a typical user could easily make, even 
in a compiled language such as C or Fortran: vectorization provides the performance, at the library level.
\item Rich set of elementary functions: \scifun{sind} (degree), \scifun{sinh} (hyperbolic).
\item Matrix language : simple, fast with vectorized statements.
\end{itemize}

\subsubsection{Issues}
In this section, we present the main weak points with Scilab.
\begin{itemize}
\item The lack of a Just In Time component in the interpreter forces the user to 
write get efficiency from vectorization only. 
\item Missing functions : \scifun{hypot, norm2, expm1, tan2}, ... The specfun Forge project 
  \cite{SpecfunWWW} tries to solve this issue (project unfinished yet).
\item No \scivar{int64}.
\item No multi-core \scifun{sin}.
\item BLAS/LAPACK not used everywhere: Linpack and Eispack still in the sources.
\item No direct use of ATLAS on Linux: still possible to use Debian ATLAS, packaged by S.L..
\item Portability issue: we use the math. library (sin, cos, exp, etc...) of the compiler (gcc on 
Linux, Visual on Windows). We should use the same portable elementary functions library on all systems, 
e.g. fdlibm \cite{fdlibm}.
\item Partial lack of floating point support: not all functions manage \scivar{\%inf} or \scivar{\%nan}, 
  no way to set IEEE rounding mode, the \scifun{format} function does not display 
  the number of digits associated with the precision of doubles.
\item Partial lack of unit tests of elementary, special functions, including accuracy.
\item Missing test matrices: Wilkinson, Ding-Dong, VanDerMonde, ... 
  The Forge/Atoms testmatrix project \cite{MakematrixWWW} tries to solve this issue (project unfinished yet).
\item No support for numerical testing. 
  The Forge/Atoms assert project \cite{AssertWWW} tries to solve this issue.
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Classics in numerical analysis}

In this section, we focus on features which could technically be removed from Scilab, but 
make this tool interesting. 
At least 50\% of the users actually use at least one of these features daily. 
These features are classics in numerical analysis and are typically found in Matlan, Octave, R or 
in numerical libraries such as Numerical Recipes, IMSK, NAG. GSL.

\subsubsection{Features}

In this section, we describe the following features of Scilab:
\begin{itemize}
\item Differential equations,
\item Integration,
\item Nonlinear equations,
\item Optimization,
\item Probabilities / Statistics,
\item Interpolation.
\end{itemize}

The following is an overview the functions in these classic fields of computational 
mathematics.

\begin{itemize}
\item Differential equations : \scifun{ode, bvode, dassl,} etc...
Computes the solution \scivar{y(t)} of $dy(t)/dt=f(y)$ with x real vector. 
This module includes a collection of algorithms: 
    \begin{itemize}
    \item Stiff problems :  Backward Differentiation Formula (BDF) from Odepack,
    \item Non-stiff problems : Adams method from Odepack,
    \item Adaptive Runge-Kutta of order 4 (RK4),
    \item Shampine and Watts program based on Fehlberg's Runge-Kutta pair of order 4 and 5,
    \item Root finding from Odepack,
    \item Discrete time simulation.
    \end{itemize}
This module can manage the following type of right hand side of the first order differential equation:
    \begin{itemize}
    \item Macros (functions) with header \scifun{ydot = f(t,y)}, with, if required, optional arguments.
    \item Fortran or C dynamically linked functions with header \scifun{fex(int *n,double *t,double *y,double *ydot)}.
    \end{itemize}
\item Integration : \scifun{integ}, \scifun{integrate} (macro for string expressions)
    \begin{itemize}
    \item Computes $y=\int_a^b f(x)dx$ with \scivar{x} real  scalar and $f$ a function.
    \item Typical use: \scivar{I=intg(a,b,f)} where \scifun{y=f(x)}.
    \item The \scifun{intg} function can manage macros (functions) or Fortran or C dynamically linked functions.
    \end{itemize}
\item Nonlinear equations: \scifun{fsolve}. 
    \begin{itemize}
    \item Computes \scivar{x} real vector such that $f(x)=0$ with $f$ a multivariable function.
    \item Typical use: \scivar{x=fsolve(x0,f)} where \scifun{y=f(x)}.
    \item The \scifun{fsolve} function can manage macros (functions) or Fortran or C dynamically linked functions.
    \item The Jacobian can be provided, but is optionnal.
    \end{itemize}
\item Nonlinear unconstrained or bound constrained optimization (needs derivatives): \scifun{optim}
    \begin{itemize}
    \item Typical use: \scivar{[fopt,xopt]=optim(f,x0)} where \scifun{[f,g,ind]=f(x,ind)}.
    \item The \scifun{optim} function can manage macros (functions) or Fortran or C dynamically linked functions.
    \item The \scifun{derivative} function computes the gradient of the objective function by finite differences.
    \end{itemize}
\item Other Optimisation solvers
    \begin{itemize}
    \item Nonlinear least squares (needs derivatives): \scifun{leastsq}, \scifun{lsqrsolve}
    \item Nonlinear objective, without constraints or with bounds (does not need derivatives): \scifun{fminsearch}
    \item Linear, quadratic optimization: \scifun{qld, karmarkar, qpsolve, qp\_solve}
    \item Global optimisation: genetic algorithms \scifun{optim\_ga}, simulated annealing \scifun{optim\_sa}
    \item Semidefinite programming: \scifun{semidef}
    \item Linear Matrix Inequality Solver: \scifun{lmisolver}
    \end{itemize}
\item Probability / Statistics
    \begin{itemize}
    \item 6 Uniform Random Number generators: \scifun{u = grand(1000,5,"def")}
    \item Including Mersenne Twister by Matsumoto and Nishimura: large period about $2^{19937}$ so that 
      any simulation is guaranteed to use only a small fraction of the overall period.
    \item 14 Non-uniform Random Number Generators: Normal, Exponential, Poisson, Geometric, etc...
    \item Typical use: \scivar{Y=grand(m,n,"nor",av,sd)}
    \item 11 Cumulated Distribution Functions and their inverse: Normal, Exponential, Beta, etc...
    \item Typical use is \scivar{[P,Q]=cdfnor("PQ",X,Mean,Std)}.
    \item Provides \scivar{P,Q} for increased accuracy for small probabilities.
    \item Many other functions: \scifun{mean, variance, st\_deviation, pca}, etc...
    \end{itemize}
\item Interpolation.
    \begin{itemize}
    \item 15 functions for 1D, 2D or 3D interpolation
    \item linear interpolation with \scifun{interpln}
    \item spline interpolation with \scifun{splin}
    \end{itemize}
\end{itemize}
We emphasize that several toolboxes are available which are useful complements to the built-in functions.
\begin{itemize}
\item the Forge/Atoms Quapro Toolbox \url{http://forge.scilab.org/index.php/p/quapro/}
which provides linear and linear quadratic optimization solvers.
\item the Forge/Atoms Integration Problems Toolbox \url{http://forge.scilab.org/index.php/p/intprbs} 
which provides 23 test problems for multi-dimensionnal integration.
\item the Forge/Atoms CUTEr Toolbox \url{http://forge.scilab.org/index.php/p/cuter/} 
which provides test problems for nonlinear optimization optimization.
\item the Forge/Atoms Unconstrained Optimization Problem Toolbox \url{http://forge.scilab.org/index.php/p/uncprb/} 
which provides test problems for unconstrained optimization.
\item the Forge/Atoms Low Discrepancy Sequences Toolbox \url{http://forge.scilab.org/index.php/p/lowdisc/} 
which allows to create sequences such as Halton, Sobol, etc...
\end{itemize}


\subsubsection{Libraries}
The libraries which are providing the classic computational features in Scilab are the following.
\begin{itemize}
\item Quadpack: \url{http://www.netlib.org/quadpack}, a package for the numerical computation of definite one-dimensional integrals.
\item Odepack: \url{http://www.netlib.org/odepack}, a collection of Fortran solvers for the initial value problem for ordinary differential equation systems.
\item Modulopt: \url{http://www-rocq.inria.fr/~gilbert/modulopt/}, a collection of optimization solvers.
\item Minpack: \url{http://www.netlib.org/minpack/}, a Fortran 77 code for solving nonlinear equations and nonlinear least squares problems.
\item Dcdflib: \url{http://www.netlib.org/random/}, a Fortran 77 code for cumulative distribution functions, inverses, and parameters.
\item Many macros: e.g. \scifun{derivative}
\end{itemize}

\subsubsection{Strong points}
In this section, we describe the main advantages of using the classic features of Scilab.
\begin{itemize}
\item Accurate algorithms: floating point aware.
\item Flexible functions: can drive either Scilab-defined or external codes in C or Fortran.
\item Robust algorithms: most algorithms are used for decades.
\end{itemize}

\subsubsection{Issues}
\begin{itemize}
\item Partial lack of documentation for complicated algorithms such as \scifun{ode}.
\item No odes with delay.
\item No use of Sundials \url{https://computation.llnl.gov/casc/sundials/}, which is used in XCos.
\item No Brent algorithm such as Matlab's \scifun{fminbnd} to minimize $f(x)$ when $x$ is scalar.
\item No Dekker/Bus/Brent algorithm such as Matlab's \scifun{fzero} for $f(x)=0$ when $x$ is scalar.
\item No non linear optimisation algo with nonlinear constraints. 
The Forge/Atoms ipopt project \url{http://forge.scilab.org/index.php/p/sci-ipopt} tries 
to provide an interface to Ipopt (project unfinished yet).
The Forge/Atoms fmincont project \url{http://forge.scilab.org/index.php/p/fmincont/} tries to 
provide a \scifun{fmincon} function, similar to Matlab's (project unfinished yet).
\item There is no Probability Distribution Function provided by Scilab. 
The Forge distfun \url{http://forge.scilab.org/index.php/p/distfun/} tries to solve this issue (unfinished yet).
\item It is not possible to have a callback containing the primitive as in the 
callee \url{http://bugzilla.scilab.org/show_bug.cgi?id=1657}.
For example, assume that \scifun{f} is the right hand side of an ODE. 
We call \scifun{ode} with \scifun{f} as input argument, then the body of \scifun{f} cannot 
contain a call to the \scifun{ode} function.
\end{itemize}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Advanced numerical methods and tools}

In this section, we present advanced numerical methods and tools. 
Less than 10\% of the users actually use at least one of these features daily. 
These features are rather advanced tools in numerical analysis and are not 
found in all technical computing environments. 

\begin{itemize}
\item Sparse matrices.
  \begin{itemize}
  \item Storage of sparse matrices
  \item Basic algebra \scivar{+,-,*,./} and functions number of nonzeros: \scifun{nnz}
  \item Conversion from other formats: \scifun{full, adj2sp, spcompack, mtlb\_sparse}, 
    Harwell-Boeing: \scifun{ReadHBSparse}, Matrix Market: \scifun{mminfo, mmread, mmwrite}.
  \item Generation of random sparse matrices: \scifun{sprand}
  \item Sparse LU decomposition and solver: \scifun{lufact, lusolve}
  \item Sparse Cholesky decomposition: \scifun{spchol}
  \item Iterative methods to solve linear equations: \scifun{gmres, pcg, qmr}
  \item Sparse LU decomposition with UMFPACK: \scifun{umf\_lufact, umf\_lusolve}
  \item Sparse Cholesky decomposition with TAUCS: \scifun{taucs\_chfact, taucs\_chsolve}
  \item Eigenvalue problem by Implicit Restarted Arnoldi Method
  \end{itemize}
\item Polynomials.
  \begin{itemize}
  \item definition of polynomials with \scifun{poly}
  \item algebra: \scivar{+,-,*,/} by overloading of operations
  \item \scifun{root}: fast RPOLY routine or eigenvalues of companion matrix
  \item Greatest Common Divisor \scifun{gcd}, Least Common Multiple \scifun{lcm}
  \item fast evaluation with \scifun{horner}
  \item many other algorithms related to CACSD.
  \end{itemize}
\item Control: the CACSD module - many, many functions.
\item Signal Processing, including filters, \scifun{fft} and \scifun{fftw}
\item Sound file handling, including reading and writing of .au and wav files.
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Floating point support}

At the very basic level, Scilab manages double precision floating point numbers. 
Hence, any feature which improves the management of doubles improves Scilab as 
a whole. 
In this section, we present a short list of possible tasks on this topic.

\begin{itemize}
 \item hypot : square root of sum of squares. Avoids unnecessary overflow.
 \item set rounding mode : set the processor rounding mode to one of the four IEEE rounding modes : 
 to-nearest (default), towards zero, towards +infinity, towards -infinity. 
 This allows to detect sensitivity to rounding errors in some cases.
 \item format double, format single: allows to display the exact number of digits 
 to be used for that precision. 
 The current format function only takes as input argument the total number of 
 caracters, which is useless.
 What we need is 17 digits after the decimal point for doubles, 9 digits for single.
 \item move the default to ieee(2).
 \item norm with dnrm2 : \url{http://www.netlib.org/blas/dnrm2.f} The current norm function 
 is a macro, using a basic trick for scaling and avoiding overflows. This trick costs more 
 than it should.
 \item standard ISO C functions: copysign, scalbn, signbit, isfinite, isinf, isnormal, fpclassify, fma

\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Complex support}

In this section, we present some issues which could be solved related 
to the management of complex variables (for which the imaginary part is nonzero).

\begin{itemize}
 \item Provide a tool to visualize the branch cuts. \url{http://www.mathworks.com/company/newsletters/news_notes/clevescorner/sum98cleve.html}
 \url{http://www.mathworks.com/company/newsletters/news_notes/clevescorner/summer98.cleve.html}
 \item Provide a document with branch cuts of all functions. They are currently completely unknown. 
 A work should be done to make this point clearer.
 \item complex division algorithm. 
 It has been proved in "Scilab is not naive" that the
 current algorithm can fail.
 Better algorithms exist and should be used.
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Elementary and special functions}

In this section, we present several projects which may allow to solve issues related 
to elementary functions.

\begin{itemize}
 \item Portability and fdlibm : TODO
 \item Missing special functions : nchoosek, binomialln, permutations, permutationsln, 
 FresnelC, FresnelS, log1p, expm1, lambertW
 \item Create a sufficiently large testing framework to assess the numerical quality and stability 
 of a Scilab release with respect to elementary functions. 
 There is currently almost nothing.
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{The current state}

The elementary functions such as sin, cos, tan, asin, acos, atan, sqrt, 
exp, log are provided by the compiler. Therefore, they are operating-
system dependent. For example, we may get different results for the 
computation of $\sin(2^{64})$ on Windows and on Linux, 
or on Linux 32 bits and Linux 64 bits.

gammainc is not in Scilab

TODO : finish that section.

\subsection{Why it fits in Scilab scope}

TODO : finish that section.

\subsection{Existing features in Matlab}

\begin{itemize}
 \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/hypot.html}{hypot}
 \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/airy.html}{airy}
 \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/ellipj.html}{ellipj}
 \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/gamma.html}{gamma}
\end{itemize}


\subsection{Suggested library to connect}

TODO : finish that section.

\subsection{Existing tools which may require an update}

TODO : finish that section.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Dense linear algebra}

Dense linear algebra is what Scilab is designed for. 
Hence, it should remain at the center of our math. focus. 

A first step should be to analyze the current state of dense linear 
algebra in Scilab. 
\begin{itemize}
 \item Why is Linpack, Eispack libraries in the sources ?
 \item Why are there patched Lapack routines in the sources ? Are these patches still required ?
 \item What is the exact problem solved by unsfdcopy ? 
 \item Is the current version of the Lapack library still sufficiently covered by the existing gateways ?
 \item Provide sufficient information for using optimized libraries for example: how to use ATLAS for Gnu/Linux. 
 Provide sufficient information about the utility of optimized libraries. 
 \item Create a sufficiently large testing framework to assess the numerical quality of a Scilab release 
 with respect to linear algebra. 
 There is currently almost nothing.
 \item In the optimization libraries behind \scifun{optim}, the dense linear algebra routines are hard-coded. 
 We should updated them and connect BLAS/LAPACK instead.
\end{itemize}

TODO : finish that section.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Sparse linear algebra}

In this section, we present developments which could be done for the management 
of sparse matrices in Scilab.

\subsection{Why it fits in Scilab scope}

Efficient linear algebra is the main topic in Scilab. 
Among other applications, sparse matrices can be used in Finite Elements computations.
Large sparse matrices require to use iterative linear algebra solvers, 
although direct sparse methods can also handle sparse matrices in 
some cases.

\subsection{Existing features in Matlab}

\begin{itemize}
 \item Linear Algebra
   \begin{itemize}
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/cholinc.html}{cholinc}	: Sparse incomplete Cholesky and Cholesky-Infinity factorizations
   \item \href{http://www.mathworks.fr/access/helpdesk/help/techdoc/ref/condest.html}{condest}	: 1-norm condition number estimate
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/eigs.html}{eigs}	: Largest eigenvalues and eigenvectors of matrix
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/ilu.html}{ilu}	: Sparse incomplete LU factorization
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/luinc.html}{luinc}	S: parse incomplete LU factorization
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/normest.html}{normest}	: 2-norm estimate
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/spaugment.html}{spaugment}	: Form least squares augmented system
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/sprank.html}{sprank}	: Structural rank
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/svds.html}{svds}	: Find singular values and vectors
   \end{itemize}
 \item Linear Equations (Iterative Methods)
   \begin{itemize}
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/bicg.html}{bicg}	: Biconjugate gradients method
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/bicgstab.html}{bicgstab}	: Biconjugate gradients stabilized method
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/bicgstabl.html}{bicgstabl}	: Biconjugate gradients stabilized (l) method
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/cgs.html}{cgs}	: Conjugate gradients squared method
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/gmres.html}{gmres}	: Generalized minimum residual method (with restarts)
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/lsqr.html}{lsqr}	: LSQR method
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/minres.html}{minres}	: Minimum residual method
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/pcg.html}{pcg}	: Preconditioned conjugate gradients method
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/qmr.html}{qmr}	: Quasi-minimal residual method
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/symmlq.html}{symmlq}	: Symmetric LQ method
   \item \href{http://www.mathworks.com/access/helpdesk/help/techdoc/ref/tfqmr.html}{tfqmr}	: Transpose-free quasi-minimal residual method
   \end{itemize}
\end{itemize}

\subsection{The current state}

Internally, the backslash and slash operators are associated with the Sparse 
package written by Kenneth S. Kundert and Alberto Sangiovanni-Vincentelli :
\url{http://www.netlib.org/sparse/}

This library is used by the functions lufact, lusolve, luget and ludel. 
In other words, when the backslash operator is used on a sparse matrix, 
it is as if the lufact, lusolve and ludel functions were called (in this order). 
This is done by overloading, in the \verb|\%sp_l_sp.sci| and \verb|\%sp_r_sp.sci| macros.

The Arnoldi package is a reverse communication module which allows to compute some 
eigenvalues of a sparse matrix : 
\url{http://www.scilab.org/product/man/dnaupd.html}{dnaupd}

On another hand, we find two packages :
\begin{itemize}
 \item the Taucs package, which provides a direct Cholesky algorithm for sparse matrices :
 \url{http://www.scilab.org/product/man/taucs_chfact.html}
 \item the UMFPACK package, which provides a direct LU algorithm for sparse matrices :
 \url{http://www.scilab.org/product/man/umf_lufact.html}
\end{itemize}

The Benchmark shown at :
\href{http://gitweb.scilab.org/?p=scilab.git;a=blob_plain;f=scilab/modules/umfpack/examples/bench.txt;h=e5ba9f7d4fee1961e94ef596eb65e222d866dadc;hb=HEAD}{scilab/modules/umfpack/examples/bench.txt}
shows that the UMFPACK functions are much faster than the backslash operator from the Sparse package.

The scilin project :
\url{http://www.irisa.fr/aladin/codes/SCILIN/}
aims at providing sparse linear algebra routines. 
This project is currently under update on Scilab's Forge :
\url{http://forge.scilab.org/index.php/p/scilin/}

Some routines developped in Scilin have already been integrated into Scilab : 
\begin{itemize}
 \item \href{http://www.scilab.org/product/man/pcg.html}{pcg} : precondioned conjugate gradient
 \item \href{http://www.scilab.org/product/man/qmr.html}{qml} : quasi minimal resiqual method with preconditioning
\end{itemize}

According to \cite{ScolaLipsol1997}, the \scifun{spchol} function 
\href{http://www.scilab.org/product/man/spchol.html}{spchol} uses two 
Fortran packages: a sparse Cholesky factorization package
developed by Esmond Ng and Barry Peyton at ORNL and a multiple
minimun-degree ordering package by Joseph Liu at University of Waterloo.

The current state of Scilab with respect to sparse linear algebra is 
confusing in the sense of many tools are providing nearly similar 
features or inconsistent tools.
For example, the sparse LU decomposition is provided by both the functions lufact and umf\_lufact.
Similarily, the sparse Cholesky decomposition is provided by the functions chfact, spchol 
and taucs\_chfact).
Moreover, the iterative solvers (e.g. pcg, qmr) are using preconditionners which are not 
provided by Scilab. 
Indeed, the solvers (e.g. pcg) have been integrated from Scilin to Scilab, but not the 
preconditionners that Scilin were providing.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Optimization}
In this section, we present a list of missing optimization features in Scilab. 
Theses features are not available in current Scilab toolboxes.
\begin{itemize}
 \item Non-linear objective with non linear constraints
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Why it fits in Scilab scope}
Optimization features are already part of current Scilab features and several Scilab toolboxes.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Existing features in Matlab}

Matlab provides the fmincon function, which searches for the local 
minimum of a nonlinear function with nonlinear constraints :
\href{http://www.mathworks.com/access/helpdesk/help/toolbox/optim/ug/fmincon.html}{fmincon}

Matlab provides the bintprog, which solves binary integer programming problems :
\href{http://www.mathworks.com/access/helpdesk/help/toolbox/optim/ug/bintprog.html}{bintprog}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Bug fixes in genetic algorithms}

There are design, documentation and testing issues with this component.
The following is a list of bug to be fixed.
\begin{itemize}
\item The optim\_ga function does not protect against unexpected parameters. 
\url{http://bugzilla.scilab.org/show_bug.cgi?id=7885}

\item There is a design issue with optim\_ga. 
\url{http://bugzilla.scilab.org/show_bug.cgi?id=7705}

\item The optim\_moga, optim\_nsga and optim\_nsga2 functions have no examples. 
\url{http://bugzilla.scilab.org/show_bug.cgi?id=8414}

\item The optim\_moga, optim\_nsga and optim\_nsga2 functions do not take into account for the additionnal arguments in the cost
function. 
\url{http://bugzilla.scilab.org/show_bug.cgi?id=8415}
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Bug fixes in fminsearch}

There are limitations and design issues with fminsearch.
The following is a list of bug to be fixed.
\begin{itemize}
\item The fminsearch function does not allow to interrupt the algorithm. 
\url{http://bugzilla.scilab.org/show_bug.cgi?id=7890}

\item The neldermead component has too many options. 
\url{http://bugzilla.scilab.org/show_bug.cgi?id=7891}

\item The demonstrations of the nmplot functions generate warnings. 
\url{http://bugzilla.scilab.org/show_bug.cgi?id=7723}
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Bug fixes in simulated annealing}

There are limitations and design issues with optim\_sa.
The following is a list of bug to be fixed.
\begin{itemize}
\item The optim\_sa example does not work compt\_sa should be replaced by comp\_t\_params.
\url{http://bugzilla.scilab.org/show_bug.cgi?id=5548}

\item Also, the same design issues of the genetic algorithms are true for the simulated annealing. 
This includes the management of callbacks \url{http://bugzilla.scilab.org/show_bug.cgi?id=7705} 
and the protection against unexpected parameters \url{http://bugzilla.scilab.org/show_bug.cgi?id=7885}.
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Suggested library to connect}

OPT++ \href{https://software.sandia.gov/opt++/}{opt++} is a library of nonlinear 
optimization algorithms written in C++. 
The motivation for this package is to build an environment for the rapid 
prototyping and development of new optimization algorithms. 
In particular, the focus is on robust and efficient algorithms for problems 
in which the function and constraint evaluations require the execution 
of an expensive computer simulation. 
Currently, OPT++ includes the 
classic Newton methods, a nonlinear interior-point method, parallel 
direct search, generating set search, a trust region - parallel direct 
search hybrid, and a wrapper to NPSOL. 
Between these methods, a wide 
range of problems can be solved, e.g. with or without constraints, with 
or without analytic gradients, simulation based, etc. OPT++ 2.4 is now 
available on a variety of platforms under the GNU Lesser General Public 
License" Opt++ is developed at CSMR Department Projects at Sandia 
National Labs in California by Patty Hough, Juan Meza, Ricardo Oliva, 
Pam Williams.

OPT ++ is available under the GNU Lesser General Public License. It is ported for Linux, Cygwin.

Coin-OR (more specifically CLP and CBC) is a linear programming library 
can do mixed integer programming, supports sparse matrixes and was 
before 2004 a commercial product from IBM (OSL). This library was 
competing (and is still competing) with CPLEX. Interface to CLP is the 
subject of SEP \#6 by Yann Collette :
\href{http://viewvc.scilab.org/bin/cgi/viewvc.cgi/trunk/SEP/SEP_6_clp.odt}{SEP clp}

\subsection{Existing tools which may require an update}

ConMinis a fortran routine written by G. Vanderplaats at NASA for 
Nastran.ConMin is behind every optimization performed with Nastran. 
This optimization method allows to perform constrained optimization and is 
based on the feasible directions method (no problem with a Hessian 
matrix, only vectors are stored). 
A first toolbox has been written to interface this method to Scilab.
\href{http://www.scilab.org/contrib/index_contrib.php?page=displayContribution&fileID=1086}{Contribution 1086}

\subsection{Current projects to provide the feature}

The sci-ipopt project aims at providing an interface to IPOPT :
\href{http://forge.scilab.org/index.php/p/sci-ipopt/}{sci-ipopt}

The fmincon project aims at providing the fmincon function in Scilab, by using the ipopt solver :
\href{http://forge.scilab.org/index.php/p/fmincon}{fmincon}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Modelization}
This is a list of missing features in Scilab:
\begin{itemize}
 \item non linear modelling: neural networks, Kriging, statistical modeling;
 \item linear modelling: LASSO for example;
\end{itemize}

\subsection{Why it fits in Scilab scope}
Non linear models are used in almost all scientific disciplines like systems control, optimization, simulation, etc ...

\subsection{Existing features in Matlab}

TODO : finish this section

\subsection{Suggested libraries to connect}
\begin{itemize}
 \item LOLIMOT (LOcal LInear MOdel Tree);
 \item DACE (A Kriging toolbox);
 \item MARS and PolyMARS (modelization based on piecewise linear models);
 \item CART (Classification And Regression Tree);
\end{itemize}

\subsection{Discussion}

\begin{itemize}
  \item What is missing for Kriging ? The DACE module is already available in ATOMS :
  \url{http://atoms.scilab.org/toolboxes/dace_scilab}

  \item Lolimot. There exists the Lolimot module :
  \url{http://atoms.scilab.org/toolboxes/lolimot}
  What work exactly is necessary ?
  
  \item MARS and PolyMARS (modelization based on piecewise linear models) : What library ?
  \item CART (Classification And Regression Tree) : What library ?
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Statistics}
Statistics are partially covered by current Scilab features, but some tools are still missing :
\begin{itemize}
 \item bootstrap algorithms to compute the sensitivity of one statistic measure against the data
 \item more probability density functions, more CDF
\end{itemize}

The function is provided in Scilab with the cdfbet function :
\url{http://www.scilab.org/product/man/cdfbet.html}
but the Matlab functions allow to expand the input arguments, in the 
case where one argument is a scalar and another argument is a matrix.


\subsection{Why it fits in Scilab scope}
Scilab already include several statistical functions.

\subsection{Existing features in Matlab}

Matlab provides the haltonset, sobolset and scramble functions in the Statistics toolbox :
\begin{itemize}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/haltonset.html}{haltonset}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/sobolset.html}{sobolset}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/qrandset.scramble.html}{qrandset.scramble}
\end{itemize}

Matlab provides a collection of PDFs, CDFs and associated random number generators.
For example, it provides the betapdf, betacdf, betainv and betarnd functions :
\begin{itemize}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/betapdf.html}{betapdf}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/betacdf.html}{betacdf}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/betainv.html}{betainv}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/betarnd.html}{betarnd}
\end{itemize}

The binopdf function in Matlab :
\href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/binopdf.html}{binopdf}
or the normpdf functions 
\href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/normpdf.html}{normpdf}
are easy to develop in Scilab, but this is a loss of time.
Even more, naive implementations leads to wrong numerical 
results. This topic is developped on the wiki at :
\href{http://wiki.scilab.org/Contributor_-_stats}{Contributor - stats}

Matlab provide several fitting functions, based on maximum log-likelihood 
principle :
\begin{itemize}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/betafit.html}{betafit}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/binofit.html}{binofit}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/lognfit.html}{lognfit}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/normfit.html}{normfit}
\end{itemize}

Matlab provides negative likelihood functions for parameter estimations :
\begin{itemize}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/normlike.html}{normlike}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/betalike.html}{betalike}
\end{itemize}

The ksdensity function in Matlab provides a kernel smoothing density estimate :

\href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/ksdensity.html}{ksdensity}

Matlab provides statistics associated with common distribution functions :
\begin{itemize}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/normstat.html}{normstat}
 \item \href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/hygestat.html}{hygestat}
\end{itemize}

Matlab provides several plotting features, including boxplots :
\href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/boxplot.html}{boxplot}
and DOE plots :
\href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/interactionplot.html}{interactionplot}

Matlab provides hypothesis testing functions, such as Kolmogorov-Smirnov one sample test :
\href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/kstest.html}{kstest}
or one sample T-test :
\href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/ttest.html}{ttest}


\subsection{Existing tools which may require an update}

Low Discrepancy Sequences
The module :

http://atoms.scilab.org/toolboxes/lowdisc

provides a first implementation for these sequences.
The work which remains to be done is : 
\begin{itemize}
 \item improving the speed by using vectorized statements, 
 \item providing scrambling algorithms (such as Kocis and Whiten's).
\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Design of Experiments}
Design of experiments are a method to approximate the behavior of a system with polynomials.

DOE are completely uncovered by current Scilab features. 
To include it into Scilab, the following features should be added :
\begin{itemize}
 \item management of integer uplets (combinations),
 \item management of several classes of polynomials : order 1, order 2, reduced order 2,
 \item management of several classes of DOEs : full factorial, centered composite.
\end{itemize}

Matlab currently provides the following DOE features :
\begin{itemize}
 \item Full factorial
 \item Fractional factorial
 \item Response surface (central composite and Box-Behnken)
 \item D-optimal
 \item Latin hypercube
\end{itemize}

\subsection{Suggested libraries to connect to Scilab}
Lolimot \url{http://lolimot.sourceforge.net/} is a project developed by Yann Collette for the management of DOEs in Scilab. It is available with LGPL license :  The scilab package is dedicated to design of experiments for:
\begin{itemize}
 \item polynomials model (Full factorial, D optimal, etc ...);
 \item non linear models (Latin Hypercube Sampling, etc ...).
\end{itemize}
The DOE tools are available at :
\begin{center}
\url{http://lolimot.cvs.sourceforge.net/viewvc/lolimot/scilab/doe/}
\end{center}

\subsection{Why it fits in Scilab scope}
DOEs would particularly fit in the Scilab environment because of the following reasons.
\begin{itemize}
 \item The Response Surface Method (RSM) allows to approximate a model based on a polynomial meta-model. 
 The points used to compute the coefficients of the meta-model are produced by the DOE. 
 The computation of the coefficients of the polynomials are based on linear algebra algorithms, in particular least squares, which already exist in Scilab.
 \item Once created, the user can optimize the meta-model with the optimization features provided 
 by Scilab.
\end{itemize}

\subsection{Existing features in Matlab}

The ff2n function provides a two-level full factorial design :

\href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/ff2n.html}{ff2n}

while the fullfact function provides the same for an arbitrary number of levels :

\href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/fullfact.html}{fullfact}

The bbdesign function provides a Box-Behnken design :

\href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/bbdesign.html}{bbdesign}

The ccdesign function provides a Central Composite design :

\href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/ccdesign.html}{ccdesign}

The lhsdesign provides a Latin Hypercube sampling design :

\href{http://www.mathworks.com/access/helpdesk/help/toolbox/stats/lhsdesign.html}{lhsdesign}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Geometry}

\subsection{Features}

TODO : finish this section

\subsection{Suggested libraries to connect to Scilab}

TODO : finish this section

\subsection{Existing features in Matlab}

TODO : finish this section

\subsection{Existing tools which may require an update}

That work may be done by providing a connection to existing geometry libraries, such as the open source project CGAL : 

\url{http://www.cgal.org/}

The CGLAB toolbox is available at : 

\href{http://www.scilab.org/contrib/index_contrib.php?page=displayContribution&fileID=323}{Contribution 323}

\subsection{Why it fits in Scilab scope}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Partial Differential Equations}
PDEs appears in the following mathematical fields :
\begin{itemize}
 \item conservation laws,
 \item finite volumes,
 \item finite elements.
\end{itemize}
There is currently no Scilab component to solve PDEs. Introducing PDE solvers may require the following software components :
\begin{itemize}
 \item 1/2/3D meshes,
 \item dense or sparse linear algebra solvers (allready available in Scilab),
 \item PDE solvers.
\end{itemize}

\subsection{Why it fits in Scilab scope}

TODO : finish this section

\subsection{Existing features in Matlab}

TODO : finish this section

\subsection{Suggested library to connect}
Summary :
\begin{itemize}
 \item FreeFem : may be included in Scilab (LGPL)
 \item Clawpack : may not be included in Scilab (~research-only license), but may be provided as a Scilab toolbox
\end{itemize}

FreeFem is a Finite Element library in C++ under LGPL : 
\url{http://www.freefem.org/ff++/index.htm}

FreeFem is developped at Laboratoire Jacques-Louis Lions by highly 
recognized experts Olivier Pironneau, Frédéric Hecht, Antoine Le 
Hyaric.FreeFemis about to be released with a support for 3d problems.
The 3.0beta can be downloaded at 
\url{http://www.freefem.org/ff++/ftp/}.

FreeFem is available as a Scilab toolbox :
\href{http://www.scilab.org/contrib/index_contrib.php?page=displayContribution&fileID=149}{Contribution 149}

The toolboox SciFreefem by Frederic Hecht (modified by Yann Collette) is available :
\href{http://www.scilab.org/contrib/index_contrib.php?page=displayContribution&fileID=883}{Contribution 883}

CLAWPACK is a software package designed to compute numerical solutions to hyperbolic partial differential equations using a wave propagation approach. It is developed by Randall J. LeVeque, Jan Olav Langseth, Marsha Berger, David McQueen, Donna Calhoun, Peter Blossey, Sorin Mitran. License is "research and instructional use only." 
\url{http://www.amath.washington.edu/~claw/}

The new version of clawpack 5 (under development beta) is licenced under GPLv3+ 
\href{http://kingkong.amath.washington.edu/claw/www/claw50beta.html}{Clawpack}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Neural Networks}


\subsection{Existing features in Matlab}

Matlab provides the Neural Networks toolbox :

\href{http://www.mathworks.com/access/helpdesk/help/toolbox/nnet/}{Neural Networks}

\subsection{Suggested libraries to connect}

\begin{itemize}
 \item FANN (Fast Artificial Neural Network);
 \item SNNS (Stuttgart Neural Network System);
\end{itemize}

\subsection{Discussion}

What would be the advantage of using FANN instead of the existing ANN toolbox :
\url{http://atoms.scilab.org/toolboxes/ANN_Toolbox}

What would be a library for SNNS ?

TODO : finish that section.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Others}

There are many ! 

Some of which are :
\begin{itemize}
 \item control - CACSD module : ODEs with delays
 \item ODE : replace Odepack by Sundials
 \item Optimization : interior point solvers for LMI problems
 \item Multi-Precision Computations : \url{http://wiki.scilab.org/Contributor_-_MPFR}.
 \item Using the Boost.graph library to replace some of the algorithms in 
 Metanet : \url{http://wiki.scilab.org/Contributor_-_BoostMetanet}.
\end{itemize}

TODO : finish that section.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Conclusion}

This is a rough, unfinished, incomplete, filled with 
spell checking and basic errors, draft of a proposal of a 
mathematical roadmap for Scilab.

We have analyzed Scilab by decomposing it 
by fundamental mathematical domains, including 
elementary and special functions, sparse linear algebra, 
optimization, modelization, statistics, design of experiments, 
geometry, partial differential equations, neural networks, dense linear algebra, 
ordinary differential equations and control.

The problems associated with completing this document is nontrivial. 
Indeed, defining the current state of Scilab in each 
of its computational domains is a difficult task.
In order to define the features to update, we need to determiner their
performance and their accuracy: this is unknown to us for many features.
By performance, we mean the mathematical performance of the 
algorithms (that is, their state-of-the-art nature)
as well as their CPU speed.
Obtaining fast computations requires to use efficiently
the software and hardware currently available (e.g. multi-core architectures).
Moreover, gathering the user feedback is difficult, 
perhaps because of the open source and free nature of 
Scilab.
We emphasize that the user feedback would be a very 
efficient way of driving Scilab, since some users 
have a strong expertise in their particular domain.

In an hypothetical context with unlimited time and 
unlimited task force (with unlimited expertise), 
the following sequence of steps may be followed, in that order.
\begin{enumerate}
\item Create or update technical reports describing 
the current state of Scilab. 
The goal of these reports would not be to analyze the features in great detail, but 
only to give an overview of the existing features, the 
current implementations, there performance and accuracy.
This includes the test of the current implementations in order to know 
their performance and accuracy.

\item Update this roadmap and take decisions.

\item Update the existing features which may provide poor 
performance or poor accuracy.

\item Create new functions which may provide missing features.
\end{enumerate}

In order to updating existing features or to create new ones, we have to 
find (and select) a open-source libraries providing the feature under study, 
or to develop ourself the missing feature. 
This may be based on the internal work of the Consortium or the 
work of external contributors. These tasks are not straightforward.

Driving the roadmap might be driven by:
\begin{itemize}
\item the existing use cases provided by the users,

\item the will to explore new use cases.
\end{itemize}
The reason behind this is that choosing based on the only proposals 
of the Consortium is a somewhat impossible task, 
leading either to arbitrary choices (may be because of limited 
knowledge), or to a large and heterogeneous list of existing bug reports  
to fix or new mathematical domains to explore.

The practical situation is that we have limited time, limited task force, 
limited feedback from the users about existing use 
cases and limited will to explore new use cases.
In this context, we suggest to focus on the following 
main numerical computing domains, already covered by existing 
features in Scilab:
\begin{itemize}
\item elementary functions,
\item dense linear algebra,
\item control,
\item ordinary differential equations,
\item optimization,
\item statistics.
\end{itemize}
We feel that Symbolic computations, Design of Experiments, Partial Differential Equations, 
Finite Elements, Neural Networks, Geometry, Sparse linear algebra 
should be considered as secondary Scilab goals. This is highly questionable.
We suggest the following features updates and creations.
\begin{itemize}
\item Elementary functions: test the accuracy of existing elementary and 
update the elementary functions by connecting the Fdlibm library.
\item Sparse iterative solvers: provide pre-conditioners for sparse matrices based on an 
update of the Scilin project.
\item Statistics: test existing distribution functions and create new PDFs, CDFs, inverse
CDFs, RNGs and other statistics features (smoothing density estimate by kernel,
maximum log-likelihood fitting functions, test statistics).
\item Ordinary Differential Equations : update the Odepack solvers and replace them  
by Sundials solvers.
\item Design of Experiments: create full factorial, fractional factorial, D-optimal and 
LHS designs functions. This domain is not covered by existing features. 
Still, we forecast that the ratio between the technical difficulty and the 
practical applications favors this topic.
\end{itemize}

Moreover, we feel that creating a technical report describing the current 
state of dense linear algebra should be a secondary priority.
Indeed, this is the core of Scilab and this primary goal cannot 
be ignored. In particular, we should provide a version of Atlas for 
Gnu/Linux the same way that we provide the Intel MKL for Windows.
Moreover, we should clarify specific points, such as the presence of the 
Eispack sources in Scilab and the future evolutions required to 
use multi-core architectures, including the analysis of the 
open-source projects candidates for parallel dense linear algebra.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Acknowledgments}

This document has evolved from a wiki page managed on 
Scilab's wiki \url{http://wiki.scilab.org} into a \LaTeX document.
We would like to thank the authors who participated, at various 
degrees, to the original wiki page, including Yann Collette, Sylvestre
Ledru and Vincent Couvert.
We would like to thank Serge Steer, whose input 
has been reported in the "Others" section.
We thank Bernard Hugueney for the informations provided on the sparse algebra in Scilab.


